indexing
	description: "[
	  " Use the Message_Receiver to receive and display messages. 
	  	The messages are received via a udp (datagram) socket.
 		
		Implement the marked part of the 'execute' - method below. Take a look
		at the whole source code, especially at Instant_Messenger.
	  ";
	  
	  Authors: Keno Albrecht and Angela Nicoara
	]"

	date: "$Date: 2005/04/14 14:42:40 $";
	revision: "$Revision: 1.3 $"

class
	MESSAGE_RECEIVER

inherit

	POLL_COMMAND
		redefine
			active_medium
		end

create

	make_me

feature

	active_medium: NETWORK_DATAGRAM_SOCKET
	user_list: LINKED_LIST[USER]
	
	make_me (socket: NETWORK_DATAGRAM_SOCKET; user_list_: LINKED_LIST[USER]) is
	do
		make (socket)
		
		user_list := user_list_
	end
		
	-- Monitors the socket for the corresponding events and executes
	-- the command associated with each event that will be received.
	-- Receive and display messages.
	execute (arg: ANY) is
	do	
		-- TO BE IMPLEMENTED --
	end
		
	-- find the user in the user_list
	find_user(ip: STRING; port: INTEGER): USER is
	local
		user: USER
	do			
		from user_list.start until user_list.after loop
			user := user_list.item
			if (user.equals(ip,port)) then
				Result := user
				user_list.finish
				user_list.forth
			else
				user_list.forth
			end
		end

		if (Result = Void) then
			create user.make_me ("unknwon", ip, port)
			Result := user				
		end
	end
		
	-- print the userName and the received text on the screen
	printToScreen(userName: STRING; text: STRING) is
	do
		io.new_line
		io.new_line
		io.put_string("--- RECEIVE ---")
		io.new_line
		io.put_string("FROM: ")
		io.put_string(userName)
		io.new_line
		io.put_string(text)
		io.new_line
		io.put_string("---------------")
		io.new_line
		io.new_line			
	end

end -- class MESSEGE_RECEIVER
