indexing
	description: "[
	  "	This thread runs continuously to register with the server every
	  	60 seconds (in REGISTRATION_CLIENT).";
	  
	  Authors: Keno Albrecht and Angela Nicoara
	]"

	date: "$Date: 2005/04/14 14:42:40 $";
	revision: "$Revision: 1.3 $"
class
	REGISTRATION_THREAD

inherit
	THREAD
	
create
	make_me
	
feature
	
	server_address: STRING
	name: STRING
	port: INTEGER
	user_list: LINKED_LIST[USER]
	
	stopFlag: BOOLEAN
	
	make_me (server_address_: STRING; name_: STRING; port_: INTEGER; user_list_: LINKED_LIST[USER]) is
	do
		server_address := server_address_
		name := name_
		port := port_
		user_list := user_list_
		
		stopFlag := false
	end
	
	--THREAD SLEEP - additional feature that will be added to the THREAD class
    sleep (a_number_of_milliseconds: INTEGER) is 
         -- Sleep `a_number_of_milliseconds' ms.
    	external
        	 "C blocking macro use <windows.h>"
    	alias "Sleep"                  
    end
    
    -- Routine executed by new thread
    -- Sends information to register with the server.
    -- The server sends the list of all active clients.
	execute is
	local
		registerClient: REGISTRATION_CLIENT
	do
		from until stopFlag loop
			create registerClient.make_client(server_address, name, port, user_list)
			registerClient.registerUser  			    
			registerClient.receiveUserList
			registerClient.cleanup
			sleep(60000) -- no "wake-up" implemented yet :-(
		end
	rescue
		registerClient.cleanup
		retry
	end
	
	stop is
	do
		stopFlag := true
	end

end -- class REGISTRATION_THREAD